function[M,pol,g]=esprit(y,L)

N=length(y);
Y=hankel(y(1:end-L),y(end-L:end));
[U,S,V]=svd(Y);
M=rank(S,10^(-10));
V1=V';
Y1=V1(1:M,1:L);
Y2=V1(1:M,2:L+1);
Y11=Y1.';
Y21=Y2.';
pol=eig(pinv(Y11)*Y21);
j=find(abs(pol)<=1e-10); %find possible zero components in pol
pol(j)=[];              %remove zero components in pol
M=M-length(j);

S = svds(Y,15);

%Vandermonde matrix with pol
Z=zeros(N,M);
for i=1:length(pol)
   Z(:,i)=transpose(pol(i).^(0:N-1)); 
end
g=Z\y;

disp('condition number of the Vandermonde matrix for ESPRIT');
conditionZ=cond(Z);
disp(conditionZ);