function[M,pol,g]=matrix_pencil(y,L)

N=length(y);
Y=hankel(y(1:end-L),y(end-L:end));
[Q,R,E]=qr(Y);

M=rank(R,10^(-10));
d=diag(R(1:M,1:M));
DM=diag(d);
R1=R*E';
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% withouth preconditioner DM
%Y1=R1(1:M,1:L);
%Y2=R1(1:M,2:L+1);
%condF1=cond(pinv(Y1.')*Y2.');
%disp('2 smallest eigenvalues of A');
%S = svds(pinv(Y1)*Y2,2,'smallest')
%Y1=Y1.';
%Y2=Y2.';
%pol=eig(pinv(Y1)*Y2)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% with preconditioner DM
Y1=DM\R1(1:M,1:L);
Y11=Y1.';
Y2=DM\R1(1:M,2:L+1);
Y21=Y2.';
pol=eig(pinv(Y11)*Y21);
%condF2=cond(pinv(Y11)*Y21);
%disp('2 smallest eigenvalues of A');
%S = svds(pinv(Y11)*Y21,2,'smallest');
j=find(abs(pol)<=1e-10); %find possible zero components in pol
pol(j)=[];              %remove zero components in pol
M=M-length(j); 


%Vandermonde matrix with pol
Z=zeros(N,M);
for i=1:length(pol)
   Z(:,i)=transpose(pol(i).^(0:N-1)); 
end
g=Z\y;

disp('condition number of the Vandermonde matrix for MPM');
conditionZ=cond(Z);
disp(conditionZ);
